import type { SelectQueryBuilder, ObjectLiteral } from 'typeorm';
import type { GridFilterModel, GridSortModel } from '@mui/x-data-grid';
import { invertTableMap } from './helpers';
import { type QueryStringParameters } from './handleQueryStringParameters';
type HandleFilterAndSortProps = {
    qb: SelectQueryBuilder<ObjectLiteral>;
    tableMap?: Parameters<typeof invertTableMap>[0];
    tableDefault?: string;
    filterModel?: GridFilterModel;
    sortModel?: GridSortModel;
    quickFilterFields?: string[];
    nullsFirst?: boolean;
};
type HandleQueryProps = Omit<HandleFilterAndSortProps, 'filterModel' | 'sortModel'> & {
    queryStringParameters: QueryStringParameters;
};
export declare function handleFilterModel(qb: HandleFilterAndSortProps['qb'], filterModel: GridFilterModel, tableNameMap: ReturnType<typeof invertTableMap>, tableDefault: HandleFilterAndSortProps['tableDefault'], quickFilterFields?: HandleFilterAndSortProps['quickFilterFields']): void;
export declare function handleSortModel(qb: HandleFilterAndSortProps['qb'], sortModel: GridSortModel, tableNameMap: ReturnType<typeof invertTableMap>, tableDefault: HandleFilterAndSortProps['tableDefault'], nullsFirst: HandleFilterAndSortProps['nullsFirst']): void;
export declare function handleFilterAndSort({ qb, tableMap, tableDefault, filterModel, sortModel, quickFilterFields, nullsFirst, }: HandleFilterAndSortProps): void;
export declare function handleQuery(props: HandleQueryProps): void;
export {};
